/* $Header: /ext/yav/catty/xpx/RCS/convert.c,v 1.17 1994/04/03 15:45:15 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"
#include "infodef.h"

extern MENU infomenu[];		/* info.c */

static unsigned char lbittbl[8] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
static unsigned char rbittbl[8] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

set_ccb_sub()
{
  free_color();
  get_color(color_buf+current_pal*MAXCOLSET, MAXCOLSET);
  image_update_col();
  return 0;
}

read_ccb_sub(fp, func)
     FILE *fp;
     void (*func)();
{
  unsigned char buf[2*MAXCOLSET];
  int i, r;
  COL *p;
  
  p = color_buf;
  r = 0;
  while (fread(buf, 2*MAXCOLSET, 1, fp) != 0) {
    for (i = 0; i < MAXCOLSET; i++) {
      func(p, buf+i*2);
      p++;
    }
    r++;
  }
  if (r != MAXPALSET)
    return 1;
  return set_ccb_sub();
}

conv_ccb(p, buf)
     COL *p;
     unsigned char *buf;
{
  static unsigned char dfcoltbl[8] = {
    0, 70, 120, 160, 180, 200, 230, 255
    };
  
  p->rgb.blue = *buf & 7;
  p->rgb.red = (*buf>>3) & 7;
  p->rgb.green = ((*buf>>6) & 3)|((*(buf+1)&1) << 2);
  p->rgb.blue = dfcoltbl[p->rgb.blue];
  p->rgb.red = dfcoltbl[p->rgb.red];
  p->rgb.green = dfcoltbl[p->rgb.green];
}

/* read CE.EXE ccb */
rd_ccb(fp)
     FILE *fp;
{
  return read_ccb_sub(fp, conv_ccb);
}

#define cv5to8(x) ((x<<3)|(x&3))
conv_cxb(p, buf)
     COL *p;
     unsigned char *buf;
{
  register int i;
  
  i = *buf & 31;
  p->rgb.blue = cv5to8(i);
  i = (*buf>>5) | ((*(buf+1)&3)<<3);
  p->rgb.green = cv5to8(i);
  i = (*(buf+1))>>2;
  p->rgb.red = cv5to8(i);
}

rd_cxb(fp)
     FILE *fp;
{
  return read_ccb_sub(fp, conv_cxb);
}


imgupdate(w, h)
{
  set_image_size(w, h);
  image_update_all();
}

conv_cbbfont(p, cbb)
     unsigned char *p;
     unsigned char *cbb;
{
  int x, y;
  
  for (y = 0; y < 8; y++) {
    for (x = 0; x < 8; x++) {
      if (*cbb & lbittbl[x])
	*p = 1;
      else
	*p = 0;
      if (*(cbb+1) & lbittbl[x])
	*p |= 2;
      if (*(cbb+16) & lbittbl[x])
	*p |= 4;
      if (*(cbb+17) & lbittbl[x])
	*p |= 8;
      p++;
    }
    cbb += 2;
  }
}

set_font8x8(p, x0, y0)
     unsigned char *p;
{
  int x, y;
  
  for (y = 0; y < 8; y++) {
    for (x = 0; x < 8; x++) {
      *(imgdata+(y0+y)*imgmaxw+x0+x) = *p++;
    }
  }
}

gen_image_cbb(cbb)
     unsigned char *cbb;
{
  int x, y;
  unsigned char fontpix[8*8];
  
  for (y = 0; y < 8*16; y += 8) {
    for (x = 0; x < 8*16; x += 8) {
      conv_cbbfont(fontpix, cbb);
      set_font8x8(fontpix, x, y);
      cbb += 32;
    }
  }
}

/* read CE.EXE cbb */
rd_cbb(fp)
     FILE *fp;
{
  int r;
  unsigned char cbb_data[32*256];
  
  init_image();
  r = fread(cbb_data, sizeof(cbb_data), 1, fp);
  if (!r)
    return 1;
  gen_image_cbb(cbb_data);
  imgupdate(128, 128);
  return 0;
}

conv_csbfont(p, csb)
     unsigned char *p;
     unsigned char *csb;
{
  int x, y;
  
  for (y = 0; y < 8; y++) {
    for (x = 0; x < 8; x++) {
      if (*csb & lbittbl[x])
	*p = 1;
      else
	*p = 0;
      if (*(csb+0x20) & lbittbl[x])
	*p |= 2;
      if (*(csb+0x40) & lbittbl[x])
	*p |= 4;
      if (*(csb+0x60) & lbittbl[x])
	*p |= 8;
      p++;
    }
    csb += 2;
  }
}

csb_font1(csb, x, y)
     unsigned char *csb;
{
  unsigned char fontpix[8*8];
  
  conv_csbfont(fontpix, csb+1);
  set_font8x8(fontpix, x, y);
  conv_csbfont(fontpix, csb);
  set_font8x8(fontpix, x+8, y);
  conv_csbfont(fontpix, csb+16+1);
  set_font8x8(fontpix, x, y+8);
  conv_csbfont(fontpix, csb+16);
  set_font8x8(fontpix, x+8, y+8);
}

gen_image_csb(csb)
     unsigned char *csb;
{
  int x, y;
  
  for (x = 0; x < 4; x++) {
    for (y = 0; y < 8; y++) {
      csb_font1(csb, x*32, y*16);
      csb += 128;
      csb_font1(csb, x*32+16, y*16);
      csb += 128;
    }
  }
}

/* read CE.EXE csb */
rd_csb(fp)
     FILE *fp;
{
  int r;
  unsigned char csb_data[32*256];
  
  init_image();
  r = fread(csb_data, sizeof(csb_data), 1, fp);
  if (!r)
    return 1;
  gen_image_csb(csb_data);
  imgupdate(128, 128);
  return 0;
}

/* return pnm type number */
read_pnm_header(fp, data, colorhints, nhints)
     FILE *fp;
     int *data;
     COL *colorhints;
     int *nhints;
{
  int i, result, r, g, b;
  int datan, maxcol, datan0;
  char buf[256], *p;
  
  if (fgets(buf, sizeof(buf), fp) == NULL)
    return 0;
  if (buf[0] != 'P')
    return 0;			/* Not pnm file */
  switch (buf[1]) {
  case '1':
    result = 1;
    datan0 = 2;
    data[2] = 1;
    break;
  case '2':
    result = 2;
    datan0 = 3;
    break;
  case '3':
    result = 3;
    datan0 = 3;
    break;
  case '4':
    result = 4;
    datan0 = 2;
    data[2] = 1;
    break;
  case '5':
    result = 5;
    datan0 = 3;
    break;
  case '6':
    result = 6;
    datan0 = 3;
    break;
  default:
    return 0;			/* Not supported pnm file */
  }
  maxcol = -1;
  datan = 0;
  while (datan < datan0 && fgets(buf, sizeof(buf), fp) != NULL) {
    if (buf[0] == '#') {
      if (colorhints != NULL && nhints != NULL) {
	if (sscanf(buf, "# color:%d %d %d %d", &i, &r, &g, &b) == 4) {
	  if (i < *nhints) {
	    (colorhints+i)->rgb.red = r;
	    (colorhints+i)->rgb.green = g;
	    (colorhints+i)->rgb.blue = b;
	    if (maxcol < i)
	      maxcol = i;
	  }
	}
      }
    } else {
      for (p = buf; (i = strtol(p, &p, 10)) != 0 && datan < 3; datan++)
	data[datan] = i;
    }
  }
  if (colorhints != NULL && nhints != NULL)
    *nhints = maxcol+1;
  return result;
}

static unsigned char bitpos;
static unsigned char rddata;

read_pnm_pixels(fp, t, cp, n)
     FILE *fp;
     int t;
     COL *cp;
     int n;
{
  int i, x, rgbsw;
  unsigned char *p, *op, buf[256];
  
  switch(t) {
  case 1:
  case 2:
  case 3:
    rgbsw = 0;
    p = buf;
    *p = '\0';
    for (x = 0; x < n; x++) {
      if (*p == '\0' || *p == '\n') {
	if (fgets(buf, sizeof(buf), fp) == NULL)
	  return x;
	p = buf;
	continue;
      }
      op = p;
      i = strtol(p, &p, 10);
      if (p == op)
	continue;
      switch(t) {
      case 3:
	switch(rgbsw) {
	case 0:
	  cp->rgb.red = i;
	  break;
	case 1:
	  cp->rgb.green = i;
	  break;
	case 2:
	  cp->rgb.blue = i;
	  break;
	}
	if (++rgbsw >= 3) {
	  cp->rgb.padding = 0;
	  cp++;
	  rgbsw = 0;
	}
	break;
      case 1:
      case 2:
	cp->rgb.red = cp->rgb.green = cp->rgb.blue = i;
	cp->rgb.padding = 0;
	cp++;
	break;
      }
    }
    return x;
  case 4:
    while (n--) {
      if (bitpos == 0x01) {
	i = fgetc(fp);
	if (i == EOF)
	  return 0;
	rddata = i;
	bitpos = 0x80;
      } else {
	bitpos >>= 1;
      }
      cp->rgb.red = cp->rgb.green = cp->rgb.blue = rddata & bitpos ? 1 : 0;
      cp++;
    }
    return 1;
  case 5:
    while (n) {
      i = sizeof(buf) > n ? n : sizeof(buf);
      if (!fread(buf, i, 1, fp))
	return 0;
      p = buf;
      x = i;
      while (x--) {
	cp->rgb.red = cp->rgb.green = cp->rgb.blue = *p++;
	cp->rgb.padding = 0;
	cp++;
      }
      n -= i;
    }
    return 1;
  case 6:
    while (n) {
      i = sizeof(buf)/3 > n ? n : sizeof(buf)/3;
      if (!fread(buf, i*3, 1, fp))
	return 0;
      p = buf;
      x = i;
      while (x--) {
	cp->rgb.red = *p++;
	cp->rgb.green = *p++;
	cp->rgb.blue = *p++;
	cp->rgb.padding = 0;
	cp++;
      }
      n -= i;
    }
    return 1;
  default:
    /* unknown pnm type ??? */
    return 0;
  }
  /* NOT REACHED */
}

static COL lastcol;
static int lastcol_pixel;

color_pixel(col)
     COL *col;
{
  int i;
  COL *tbl;
  
  if (lastcol_pixel >= 0 && col->all == lastcol.all)
    return lastcol_pixel;
  tbl = color_buf;
  for (i = 0; i < MAXCOLSET*MAXPALSET; i++) {
    if (col->all == tbl->all && (coltbl[i] & (CM_ALLOCED|CM_REQUEST))) {
      lastcol = *col;
      return lastcol_pixel = i;
    }
    tbl++;
  }
  return -1;
}

conv_pnmmaxval(px, n, max)
     COL *px;
{
  if (max != 255) {
    while (n--) {
      px->rgb.red = (px->rgb.red * 255) / max;
      px->rgb.green = (px->rgb.green * 255) / max;
      px->rgb.blue = (px->rgb.blue * 255) / max;
      px++;
    }
  }
}

Bool quick_convert = False;

typedef struct {
  int i;
  int n;
  int pn;
} CLN;

colcnt(p, len, ctbl, ntbl, n, itbl)
     COL *p;
     COL *ctbl;
     CLN *ntbl;
     unsigned char *itbl;
{
  int i, x, max;
  
  max = 0;
  for (x = 0; x < len; x++) {
    i = 0;
    for (;;) {
      if (i >= max) {
	if (++max > n)
	  return -1;
	*(ctbl+i) = *p;
      }
      if ((ctbl+i)->all == p->all)
	break;
      i++;
    }
    *itbl++ = i;
    ++((ntbl+i)->n);
    p++;
  }
  return max;
}

ncolcmp(p1, p2)
     CLN *p1;
     CLN *p2;
{
  return p2->n - p1->n;
}

icolcmp(p1, p2)
     CLN *p1;
     CLN *p2;
{
  return p1->i - p2->i;
}

slow_convert(px, w, h)
     COL *px;
{
  int i, n, len, x, y;
  unsigned char *itbl, *ip;
  COL ctbl[256];
  CLN ntbl[256];
  
  len = w*h;
  itbl = (unsigned char *)malloc(len);
  for (i = 256; i; --i) {
    memset(ctbl, 0, sizeof(*ctbl)*i);
    memset(ntbl, 0, sizeof(*ntbl)*i);
    n = colcnt(px, len, ctbl, ntbl, i, itbl);
    if (n >= 0)
      break;
  }
  message("phase-1 %d colors.\n", n);
  for (i = 0; i < 256; i++)
    ntbl[i].i = i;
  qsort(ntbl, n, sizeof(*ntbl), ncolcmp);
  for (i = 0; i < n; i++)
    ntbl[i].pn = i;
  for (;;) {
    free_color_all();
    message("try %d colors.\n", n);
    for (i = 0; i < n; i++)
      request_color2(i, ctbl+ntbl[i].i);
    i = get_requested_colors();
    message("get %d/%d request colors.\n", i, n);
    if (i == n)
      break;
    n -= 16;
    if (n < 0) {
      message("!too few color!\n");
      free(itbl);
      return;
    }
  }
  qsort(ntbl, n, sizeof(*ntbl), icolcmp);
  ip = itbl;
  for (y = 0; y < h; y++) {
    for (x = 0; x < w; x++) {
      *(imgdata+y*imgmaxw+x) = ntbl[*ip++].pn;
    }
  }      
  free(itbl);
}

/* read portable bitmap/graymap/pixmap */
rd_pnm(fp)
     FILE *fp;
{
  int c, i, n, f, x, y, pnmtype;
  int data[3], w, h;
  int colcnt;
  COL *px0, *px, *px1;
  
  colcnt = MAXPALSET*MAXCOLSET;
  pnmtype = read_pnm_header(fp, data, color_buf, &colcnt);
  if (pnmtype == 0)
    return 1;
  free_color_all();
  /* magtoppm commented color information set */
  get_color(color_buf, colcnt);
  
  w = data[0];
  h = data[1];
  if (w > imgmaxw) {
    w = imgmaxw;
    message("!\nwidth %d trancate to %d.\n", data[0], w);
  }
  if (h > imgmaxh) {
    h = imgmaxh;
    message("!\nheight %d trancate to %d.\n", data[1], h);
  }
  px = (COL *)malloc(sizeof(*px)*w);
  if (!quick_convert)
    px1 = px0 = (COL *)malloc(sizeof(*px0)*w*h);
  lastcol_pixel = -1;
  for (y = 0; y < h; y++) {
    f = 1;
    bitpos = 0x01;
    for (n = data[0]; n; n -= i) {
      i = n > w ? w : n;
      read_pnm_pixels(fp, pnmtype, px, i);
      if (f) {
	conv_pnmmaxval(px, i, data[2]);
	if (quick_convert) {
	  for (x = 0; x < i; x++) {
	    c = color_pixel(px+x);
	    if (c < 0)
	      c = request_color(px+x);
	    *(imgdata+y*imgmaxw+x) = c;
	  }
	} else {
	  memcpy(px1, px, sizeof(*px)*i);
	  px1 += i;
	}
	f = 0;
      }
    }
  }
  if (!quick_convert) {
    slow_convert(px0, w, h);
    free(px0);
  } else {
    get_requested_colors();
  }
  free(px);
  imgupdate(w, h);
  return 0;
}

static char kiss_magic_number[] = "KiSS";

/* read KISS kcf */
rd_kcf(fp)
     FILE *fp;
{
  int i, s, bpc, cc, col, set, preload;
  COL *cp;
  unsigned char *p, buf[4096];
  
  preload = strlen(kiss_magic_number);
  if (!fread(buf, preload, 1, fp))
    return 1;
  if (strncmp(buf, kiss_magic_number, preload) == 0) {
    /* read new style kcf header section */
    if (!fread(buf+preload, 32-preload, 1, fp))
      return 1;
    /* check color file mark */
    if (buf[4] != 0x10)
      return 1;
    bpc = buf[5];
    col = buf[8]|(buf[9]<<8);
    set = buf[10]|(buf[11]<<8);
    preload = 0;
    infomenu[INFOMENU_GSKCF].mode |= MenuModeMaskOn;
  } else {
    /* old style kcf */
    bpc = 12;
    col = 16;
    set = 10;
    infomenu[INFOMENU_GSKCF].mode &= ~MenuModeMaskOn;
  }
  redraw_window(infomenu[INFOMENU_GSKCF].win);
  cp = color_buf;
  cc = ((bpc+7)>>3)*col;
  for (s = 0; s < set; s++) {
    if (!fread(buf+preload, cc-preload, 1, fp))
      return 1;
    p = buf;
    for (i = 0; i < col; i++) {
      if (bpc == 12) {
	cp->rgb.red = (*p&0xf0)|(*p>>4);
	cp->rgb.blue = (*p&0x0f)|((*p&0x0f)<<4);
	p++;
	cp->rgb.green = (*p&0x0f)|((*p&0x0f)<<4);
	p++;
      } else {
	cp->rgb.red = *p++;
	cp->rgb.green = *p++;
	cp->rgb.blue = *p++;
      }
      cp++;
    }
    preload = 0;
  }
  free_color();
  get_color(color_buf+16*current_pal, col);
  image_update_col();
  return 0;
}

/* write KISS kcf */
wr_kcf(fp)
     FILE *fp;
{
  int i, s, bpc, col, set, cc;
  COL *cp;
  unsigned char *p, buf[4096];
  
  /* old style kcf spec set */
  bpc = 12;			/* red:4 blue:4 green:4 = 12bits/color */
  col = 16;
  set = 10;
  if (infomenu[INFOMENU_GSKCF].mode & MenuModeMaskOn) {
    bpc = 24;			/* red:8 green:8 blue:8 = 24bits/color */
    memset(buf, 0, 32);
    memcpy(buf, kiss_magic_number, strlen(kiss_magic_number));
    buf[4] = 0x10;		/* color file mark */
    buf[5] = bpc;
    buf[8] = col;
    buf[9] = col>>8;
    buf[10] = set;
    buf[11] = set>>8;
    if (!fwrite(buf, 32, 1, fp))
      return 1;
  }
  cp = color_buf;
  cc = ((bpc+7)>>3)*col;
  for (s = 0; s < set; s++) {
    p = buf;
    for (i = 0; i < col; i++) {
      if (bpc == 12) {
	*p++ = (cp->rgb.red & 0xf0)|(cp->rgb.blue >> 4);
	*p++ = cp->rgb.green >> 4;
      } else {
	*p++ = cp->rgb.red;
	*p++ = cp->rgb.green;
	*p++ = cp->rgb.blue;
      }
      cp++;
    }
    if (!fwrite(buf, cc, 1, fp))
      return 1;
  }
  return 0;
}

/* read KISS cel */
rd_cel(fp)
     FILE *fp;
{
  int c, x, y, w, h, preload, bpp;
  int dataw, datah;
  unsigned char buf[4096];
  
  preload = strlen(kiss_magic_number);
  if (!fread(buf, preload, 1, fp))
    return 1;
  if (strncmp(buf, kiss_magic_number, preload) == 0) {
    /* read new style cel file header section */
    if (!fread(buf+preload, 32-preload, 1, fp))
      return 1;
    /* check cel file mark */
    if (buf[4] != 0x20)
      return 1;
    bpp = buf[5];
    w = buf[8]|(buf[9]<<8);
    h = buf[10]|(buf[11]<<8);
    infomenu[INFOMENU_GSCEL].mode |= MenuModeMaskOn;
  } else {
    bpp = 4;
    w = buf[0]|(buf[1]<<8);
    h = buf[2]|(buf[3]<<8);
    infomenu[INFOMENU_GSCEL].mode &= ~MenuModeMaskOn;
  }
  redraw_window(infomenu[INFOMENU_GSCEL].win);
  dataw = w;
  datah = h;
  if (w > imgmaxw) {
    w = imgmaxw;
    message("!\nwidth %d trancate to %d.\n", dataw, w);
  }
  if (h > imgmaxh) {
    h = imgmaxh;
    message("!\nheight %d trancate to %d.\n", datah, h);
  }
  for (y = 0; y < h; y++) {
    if (!fread(buf, bpp==4?((dataw+1)>>1):dataw, 1, fp))
      return 1;
    for (x = 0; x < w; x++) {
      if (bpp == 4) {
	c = buf[x>>1];
	if ((x & 1) == 0)
	  c >>= 4;
	else
	  c &= 0x0f;
      } else {
	c = buf[x];
      }
      *(imgdata+y*imgmaxw+x) = c;
    }
  }
  imgupdate(w, h);
  return 0;
}

/* write KISS cel */
wr_cel(fp)
     FILE *fp;
{
  int c, x, y, w, h, bpp, headersize;
  unsigned char buf[4096];
  
  w = imgfilew;
  h = imgfileh;
  bpp = 4;			/* 4bits/pixel */
  if (infomenu[INFOMENU_GSCEL].mode & MenuModeMaskOn) {
    headersize = 32;
    memset(buf, 0, headersize);
    memcpy(buf, kiss_magic_number, strlen(kiss_magic_number));
    buf[4] = 0x20;		/* cel file mark */
    buf[5] = bpp;
    buf[8] = w;
    buf[9] = w >> 8;
    buf[10] = h;
    buf[11] = h >> 8;
  } else {
    headersize = 4;
    buf[0] = w;
    buf[1] = w >> 8;
    buf[2] = h;
    buf[3] = h >> 8;
  }
  if (!fwrite(buf, headersize, 1, fp))
    return 1;
  for (y = 0; y < h; y++) {
    for (x = 0; x < w; x++) {
      c = *(imgdata+y*imgmaxw+x);
      if (bpp == 4) {
	if ((x & 1) == 0)
	  buf[x>>1] = c<<4;
	else
	  buf[x>>1] |= c;
      } else {
	buf[x] = c;
      }
    }
    if (!fwrite(buf, bpp==4?((w+1)>>1):w, 1, fp))
      return 1;
  }
  return 0;
}

/* write portable pixmap */
wr_ppm(fp)
     FILE *fp;
{
  int i, x, y;
  COL *cp;
  unsigned char c, buf[3];
  
  fprintf(fp, "P6\n");
  fprintf(fp, "#Saved by %s %s\n", myname, rcsrev);
  /* color information */
  cp = color_buf;
  for (i = 0; i < alloced_color; i++) {
    fprintf(fp, "# color:%3d %3d %3d %3d\n", i,
	    cp->rgb.red, cp->rgb.green, cp->rgb.blue);
    cp++;
  }
  fprintf(fp, "%ld %ld\n", imgfilew, imgfileh);
  fprintf(fp, "255\n");
  
  for (y = 0; y < imgfileh; y++) {
    for (x = 0; x < imgfilew; x++) {
      c = *(imgdata+y*imgmaxw+x);
      buf[0] = color_buf[c].rgb.red;
      buf[1] = color_buf[c].rgb.green;
      buf[2] = color_buf[c].rgb.blue;
      if (!fwrite(buf, 3, 1, fp))
	return 1;
    }
  }
  return 0;
}

write_xbm_out(fp, data, datalen, end)
     FILE *fp;
     unsigned char *data;
{
  int i;
  char *p;
  char buf[256];
  
  strcpy(buf, "  ");
  p = buf+2;
  for (i = 0; i < datalen; i++) {
    sprintf(p, " 0x%02x,", *data++);
    p += strlen(p);
  }
  if (end)
    strcpy(p-1, "};");
  strcat(buf, "\n");
  return fputs(buf, fp);
}

/* write X11 bitmap */
wr_xbm(fp, name)
     FILE *fp;
     char *name;
{
  int i, x, y, w, h;
  int outcount;
  unsigned char c;
  unsigned char outbuf[12];
  char namebuf[MAXPATHLEN], *p;
  extern char *basefilename();
  
  strcpy(namebuf, name);
  p = basefilename(namebuf);
  w = imgfilew;
  h = imgfileh;
  fprintf(fp, "#define %s_width %d\n", p, w);
  fprintf(fp, "#define %s_height %d\n", p, h);
  fprintf(fp, "static char %s_bits[] = {\n", p);
  outcount = 0;
  for (y = 0; y < h; y++) {
    for (x = 0; x < w; x += 8) {
      c = 0;
      for (i = 0; i < 8; i++) {
	if ((x + i < w)&& *(imgdata+y*imgmaxw+x+i))
	  c |= rbittbl[i];
      }
      if (outcount >= sizeof(outbuf)) {
	write_xbm_out(fp, outbuf, outcount, 0);
	outcount = 0;
      }
      outbuf[outcount++] = c;
    }
  }
  write_xbm_out(fp, outbuf, outcount, 1);
  return 0;
}

/* read X11 bitmap */
rd_xbm(fp)
     FILE *fp;
{
  int i, x, y, w, h, c;
  char buf[1024], *p;
  char namebuf[256];
  
  w = h = 0;
  while (fgets(buf, sizeof(buf), fp) != NULL) {
    if (strncmp(buf, "static", 6) == 0)
      break;
    if (sscanf(buf, "#define %s %d", namebuf, &c) == 2) {
      i = strlen(namebuf);
      if (i >= 5 && strcmp(namebuf+i-5, "width") == 0)
	w = c;
      else if (i >= 6 && strcmp(namebuf+i-6, "height") == 0)
	h = c;
    }
  }
  if (!w || !h)
    return 1;
  y = x = 0;
  p = buf;
  *p = '\0';
  for (;;) {
    while (*p && (*p == ' ' || *p == '\t' || *p == ','))
      p++;
    if (*p == '\0' || *p == '\n') {
      if (fgets(buf, sizeof(buf), fp) == NULL)
	break;
      p = buf;
    }
    if (sscanf(p, "0x%02x", &c)) {
      p += 4;
      for (i = 0; i < 8; i++) {
	if (x+i < w)
	  *(imgdata+y*imgmaxw+x+i) = ((c & rbittbl[i]) ? 1 : 0);
      }
      x += 8;
      if (x >= w) {
	if (++y >= h)
	  break;
	x = 0;
      }
    } else {
      p++;
    }
  }
  imgupdate(w, h);
  return 0;
}

/* set XImage from imgdata */
setpixel_sub2(x0, y0, pixel)
{
  int x, y, x1, y1;
  
  x0 *= zoomfactor;
  y0 *= zoomfactor;
  x1 = x0+zoomfactor;
  y1 = y0+zoomfactor;
  for (y = y0; y < y1; y++)
    for (x = x0; x < x1; x++)
      XPutPixel(img, x, y, pixel);
}

/* set XImage from imgdata */
setpixel_sub(x0, y0, pixel)
{
  int x, y, x1, y1;
  
  if (vimg != NULL)
    XPutPixel(vimg, x0, y0,  pixel);
  x0 *= zoomfactor;
  y0 *= zoomfactor;
  x1 = x0+zoomfactor;
  y1 = y0+zoomfactor;
  for (y = y0; y < y1; y++)
    for (x = x0; x < x1; x++)
      XPutPixel(img, x, y, pixel);
}

/* set view image */
#define setpixel_subv(x0,y0,px) XPutPixel(vimg,(x0),(y0),(px))

setpixelcolor(x, y, col)
{
  *(imgdata+y*imgmaxw+x) = col;
  setpixel_sub2(x, y, pixtbl[col]);
  if (vimg != NULL)
    setpixel_subv(x, y, pixtbl[col]);
}

gen_image_subv(x0, y0, w, h)
{
  int x, y;
  unsigned char *ip;
  
  for (y = y0; y < y0+h; y++) {
    ip = imgdata+y*imgmaxw+x0;
    for (x = x0; x < x0+w; x++) {
      setpixel_subv(x, y, pixtbl[*ip++]);
    }
  }
}

/* set XImage from imgdata */
gen_image_sub(x0, y0, w, h)
{
  int x, y;
  unsigned char *ip;
  
  for (y = y0; y < y0+h; y++) {
    ip = imgdata+y*imgmaxw+x0;
    for (x = x0; x < x0+w; x++) {
      setpixel_sub2(x, y, pixtbl[*ip++]);
    }
  }
}

update_area(x, y, w, h)
{
  gen_image_sub(x, y, w, h);
  if (vimg != NULL)
    gen_image_subv(x, y, w, h);
}

fill_area(dstx, dsty, w, h, c)
{
  int x, y;
  
  for (y = 0; y < h; y++) {
    for (x = 0; x < w; x++) {
      *(imgdata+(dsty+y)*imgmaxw+dstx+x) = c;
    }
  }
  update_area(dstx, dsty, w, h);
}

copy_area(dstx, dsty, srcx, srcy, w, h)
{
  int x, y;
  
  if (dsty*imgmaxw+dstx > srcy*imgmaxw+srcx) {
    for (y = h-1; y >= 0; y--) {
      for (x = w-1; x >= 0; x--) {
	*(imgdata+(dsty+y)*imgmaxw+dstx+x) =
	  *(imgdata+(srcy+y)*imgmaxw+srcx+x);
      }
    }
  } else {
    for (y = 0; y < h; y++) {
      for (x = 0; x < w; x++) {
	*(imgdata+(dsty+y)*imgmaxw+dstx+x) =
	  *(imgdata+(srcy+y)*imgmaxw+srcx+x);
      }
    }
  }
  update_area(dstx, dsty, w, h);
}


gen_image_col(x0, y0, w, h)
{
  int x, y;
  unsigned char *ip;
  
  for (y = y0; y < y0+h; y++) {
    ip = imgdata+y*imgmaxw+x0;
    for (x = x0; x < x0+w; x++) {
      if (coltbl[*ip] & CM_UPDATING) {
	coltbl[*ip] |= CM_UPDATED;
	setpixel_sub2(x, y, pixtbl[*ip++]);
      }
    }
  }
  if (vimg != NULL) {
    for (y = y0; y < y0+h; y++) {
      ip = imgdata+y*imgmaxw+x0;
      for (x = x0; x < x0+w; x++) {
	if (coltbl[*ip] & CM_UPDATING) {
	  coltbl[*ip] |= CM_UPDATED;
	  setpixel_subv(x, y, pixtbl[*ip++]);
	}
      }
    }
  }
  for (x = 0; x < MAXPALSET*MAXCOLSET; x++) {
    if (coltbl[x] & CM_UPDATED)
      coltbl[x] &= ~(CM_UPDATED|CM_UPDATING);
  }
}

/* End of file */
