/* $Header: /ext/yav/catty/xpx/RCS/dir.c,v 1.4 1994/02/09 18:11:16 yav Exp $
 */

#include "config.h"

#ifndef FORK_LS
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#endif
#include <stdio.h>

#ifndef MAXPATHLEN
#define MAXPATHLEN 1024
#endif

get_current_dir(buf)
     char *buf;
{
#ifdef SYSV
  getcwd(buf, MAXPATHLEN);
#else
  getwd(buf);
#endif
}

#ifdef FORK_LS
get_dir(name, filebuf, len, slotn)
     char *name;
     char *filebuf;
{
  FILE *fp;
  int i, n;
  int fd[2];
  char buf[MAXPATHLEN];

  pipe(fd);
  i = fork();
  if (i == -1) {
    fprintf(stderr, "fork error!\n");
    return 0;
  }
  if (i == 0) {
    close(1);
    dup(fd[1]);
    close(fd[1]);
    close(fd[0]);
    execlp("ls", "ls", "-aF", name, NULL);
    fprintf(stderr, "exec ls error!\n");
    exit(1);
  }
  fp = fdopen(fd[0], "r");
  close(fd[1]);
  for (n = 0; n < slotn && fgets(buf, sizeof(buf), fp) != NULL; n++) {
    i = strlen(buf);
    if (i && buf[i-1] == '\n')
      buf[i-1] = '\0';
    if (strlen(buf) == 0)
      break;
    strncpy(filebuf+n*len, buf, len-1);
    *(filebuf+n*len+len-1) = '\0';
  }
  fclose(fp);
  wait(&i);
  return n;
}
#else /* FORK_LS */

/*
 * return : 0 error
 */
get_dir(name, filebuf, len, slotn)
     char *name;
     char *filebuf;
{
  int i, n;
  DIR *dp;
  struct direct *dir;
  struct stat statbuf;
  char buf[MAXPATHLEN];
  extern strcmp();
  
  if ((dp = opendir(name)) == NULL)
    return 0;
  for (n = 0; n < slotn && (dir = readdir(dp)) != NULL; n++) {
    if (dir->d_ino == 0)
      continue;
    strncpy(filebuf+n*len, dir->d_name, len);
    *(filebuf+n*len+len-1) = '\0';
  }
  closedir(dp);
  qsort(filebuf, n, len, strcmp);
  for (i = 0; i < n; i++) {
    sprintf(buf, "%s/%s", name, filebuf+i*len);
    stat(buf, &statbuf);
    if (statbuf.st_mode & S_IFDIR)
      strcat(filebuf+i*len, "/");
  }
  return n;
}
#endif /* FORK_LS */

#ifdef DIR_DEBUG
main()
{
  int pid;
  char buf[4096];

  start_ls_task();
  while (fgets(buf, sizeof(buf), stdin) != NULL) {
    fputs(buf, ls_writefp);
    fflush(ls_writefp);
    while(fgets(buf, sizeof(buf), ls_readfp) != NULL) {
      fprintf(stderr, ">>%s", buf);
      if (buf[0] == '\n' || buf[0] == '\0')
	break;
    }
  }
  fprintf(stderr, "main finish.\n");
  stop_ls_task();
  exit(0);
}
#endif

/* End of file */
