/* $Header: /ext/yav/catty/xpx/RCS/edit.c,v 1.10 1994/04/03 16:18:57 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <math.h>

#include "xpx.h"
#include "extern.h"
#include "editdef.h"
#include "menudef.h"
#include "cursdef.h"

extern MENU cursmenu[];

#define EDITWINW 225
#define EDITWINH 290

#define EDMW	64
#define EDMH	24

/* image.c */
extern AREA area0;
extern Bool area_flag;

static Window editwin;
static Window editfuncwin[3];
static int area_mode = 0;
static int circle_mode = 0;
static int line_mode = 0;
static POS copypos0, copysrc0, copysrc1;
static AREA copydst;

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask)
int edev();
int edev2();
static MENU menutbl[] = {
  {
    EDIT_dummy,	0,
    0, 0, EDMW, EDMH,
    0, ExposureMask, 0,
    NULL, NULL, 0, 0, "Button?"},
  {
    EDIT_PLOT,	MenuModeMaskBorder,
    0, (EDMH+BDW)*1, EDMW, EDMH,
    0, IMASK, 0,
    edev, NULL, 0, 0, "Plot"},
  {
    EDIT_COPY,	MenuModeMaskBorder,
    0, (EDMH+BDW)*2, EDMW, EDMH,
    0, IMASK, 0,
    edev, NULL, 0, 0, "Copy"},
  {
    EDIT_FILL,	MenuModeMaskBorder,
    0, (EDMH+BDW)*3, EDMW, EDMH,
    0, IMASK, 0,
    edev, NULL, 0, 0, "Boxfull"},
  {
    EDIT_LINE,	MenuModeMaskBorder,
    0, (EDMH+BDW)*4, EDMW, EDMH,
    0, IMASK, 0,
    edev, NULL, 0, 0, "line"},
  {
    EDIT_CIRCLE,	MenuModeMaskBorder,
    0, (EDMH+BDW)*5, EDMW, EDMH,
    0, IMASK, 0,
    edev, NULL, 0, 0, "circle"},
  {
    EDIT_ELLIPSE,	MenuModeMaskBorder,
    0, (EDMH+BDW)*6, EDMW, EDMH,
    0, IMASK, 0,
    edev, NULL, 0, 0, "ellipse"},
  {
    EDIT_GETCOLOR,	MenuModeMaskBorder,
    0, (EDMH+BDW)*7, EDMW, EDMH,
    0, IMASK, 0,
    edev, NULL, 0, 0, "get"},
  {
    EDIT_SCROLL,	MenuModeMaskBorder,
    0, (EDMH+BDW)*8, EDMW, EDMH,
    0, IMASK, 0,
    edev, NULL, 0, 0, "scroll"},
  {
    EDIT_CANCEL,	MenuModeMaskBorder,
    0, (EDMH+BDW)*9, EDMW, EDMH,
    0, IMASK, 0,
    edev, NULL, 0, 0, "cancel"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

static MENU menutbl2[] = {
  {
    0,	MenuModeMaskBorder,
    EDITWINW-(EDMW+BDW*2)-4, EDITWINH-(EDMH+BDW*2)-4, EDMW, EDMH,
    0, IMASK, SouthEastGravity,
    edev2, NULL, 0, 0, "OK"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};
MENU *menutblp[3];

create_edit_window()
{
  XSizeHints hint;
  int i, x, y;
  MENU *p;
  char buf[256];
  char *titles[3] = {"Button1", "Button2", "Button3"};
  
  get_drawable_size(DefaultRootWindow(dsp), &x, &y);
  hint.x = (x-EDITWINW)/2;
  hint.y = (y-EDITWINH)/2;
  hint.width = EDITWINW;
  hint.height = EDITWINH;
  hint.flags = USPosition|USSize;
  editwin = XCreateSimpleWindow(dsp, DefaultRootWindow(dsp), hint.x, hint.y,
				hint.width, hint.height,
				border_width, border_color, bg);
  sprintf(buf, "%s edit", myname);
  XSetStandardProperties(dsp, editwin, buf, buf, None, NULL, NULL, &hint);
  XSelectInput(dsp, editwin, ExposureMask);
  for (i = 0; i < 3; i++) {
    editfuncwin[i] = XCreateSimpleWindow(dsp, editwin,
					 4+(EDMW+BDW*2+4)*i, 0,
					 EDMW+BDW*2, (EDMH+BDW)*10+BDW,
					 0, fg, bg);
    XSelectInput(dsp, editfuncwin[i], ExposureMask);
    XMapWindow(dsp, editfuncwin[i]);
    menutblp[i] = (MENU *)malloc(sizeof(menutbl));
    memcpy(menutblp[i], menutbl, sizeof(menutbl));
    menutblp[i]->str = titles[i];
    menutblp[i]->cursor = i;
    (menutblp[i]+edit_mode[i])->mode |= MenuModeMaskOn;
    menuwin_create(menutblp[i], editfuncwin[i], 0, 0);
  }
  menuwin_create(menutbl2, editwin, 0, 0);
  return 0;
}

map_edit_window()
{
  XMapRaised(dsp, editwin);
}

unmap_edit_window()
{
  XUnmapWindow(dsp, editwin);
}

close_edit_window()
{
  XDestroyWindow(dsp, editwin);
}

edit_mode_change2(button, mode)
{
  if (mode != edit_mode[button]) {
    (menutblp[button]+edit_mode[button])->mode &= ~MenuModeMaskOn;
    redraw_window((menutblp[button]+edit_mode[button])->win);
    edit_mode[button] = mode;
    (menutblp[button]+edit_mode[button])->mode |= MenuModeMaskOn;
    redraw_window((menutblp[button]+edit_mode[button])->win);
  }
}

edit_mode_change(n)
{
  edit_mode_change2(0, n);
}

/* sub.c */
extern MENU *get_top_menu();

int edev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    edit_mode_change2(get_top_menu(p)->cursor, p->n);
    return 1;
  }
  return 0;
}

int edev2(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    p->mode &= ~MenuModeMaskOn;
    menu_stat_change(MENU_EDIT, 0);
    return 1;
  }
  return 0;
}

/*********************************
 * image edit function
 */

area_img_expose(x, y, w, h)
{
  calc_img_area(&x, &y, &w, &h);
  img_expose(x, y, w, h);
}

plot(x, y, c)
{
  setpixelcolor(x, y, c);
  if (vimg != NULL)
    XClearArea(dsp, viewwin, x, y, 1, 1, True);
  img_expose(x*zoomfactor-imgofsx, y*zoomfactor-imgofsy,
	     zoomfactor, zoomfactor);
}

area_update(x, y, w, h)
{
  if (vimg != NULL)
    XClearArea(dsp, viewwin, x, y, w, h, True);
  area_img_expose(x, y, w, h);
  copy_area_expose();
}

copy(dstx, dsty, srcx, srcy, w, h)
{
  copy_area(dstx, dsty, srcx, srcy, w, h);
  area_update(dstx, dsty, w, h);
}

fill(x, y, w, h, c)
{
  fill_area(x, y, w, h, c);
  area_update(x, y, w, h);
}

edit_plot(x, y)
{
  if (current_col >= 0)
    plot(x, y, current_col);
}

edit_copy_and_fill(x, y, type, em)
{
  if (type == ButtonPress) {
    switch(area_mode) {
    case 2:
      if (inarea(x, 1, copysrc0.x, copysrc1.x)&&
	  inarea(y, 1, copysrc0.y, copysrc1.y)) {
	/* area catch */
	copydst.x = x - copysrc0.x;
	copydst.y = y - copysrc0.y;
	copydst.w = copysrc1.x - copysrc0.x;
	copydst.h = copysrc1.y - copysrc0.y;
	area_mode = 3;
	break;
      }
    case 0:
      /* area mark start */
      copypos0.x = x;
      copypos0.y = y;
      area_mode = 1;
      break;
    }
  } else if (type == ButtonRelease) {
    switch(area_mode) {
    case 3:
      /* paste */
      copy(area0.x, area0.y, copysrc0.x, copysrc0.y,
	   copysrc1.x - copysrc0.x, copysrc1.y - copysrc0.y);
    case 1:
      /* area mark end */
      copysrc0.x = area0.x;
      copysrc0.y = area0.y;
      copysrc1.x = area0.w;
      copysrc1.y = area0.h;
      little_big(&copysrc0.x, &copysrc1.x);
      little_big(&copysrc0.y, &copysrc1.y);
      switch(em) {
      case EDIT_FILL:
	area_flag = False;
	area_mode = 0;
	fill(copysrc0.x, copysrc0.y,
	     copysrc1.x-copysrc0.x, copysrc1.y-copysrc0.y, current_col);
	break;
      case EDIT_COPY:
	area_mode = 2;
	break;
      }
      break;
    }
  }
  if (type == MotionNotify) {
    switch(area_mode) {
    case 1:
      /* area size update */
      if (x != area0.w || y != area0.h) {
	area0.w = x;
	area0.h = y;
	area0.x = copypos0.x;
	area0.y = copypos0.y;
	area_flag = True;
	copy_area_expose();
      }
      break;
    case 3:
      /* drug area */
      x -= copydst.x;
      if (x < 0)
	x = 0;
      if (x + copydst.w > imgfilew)
	x = imgfilew - copydst.w;
      y -= copydst.y;
      if (y < 0)
	y = 0;
      if (y + copydst.h > imgfileh)
	y = imgfileh - copydst.h;
      if (x != area0.x || y != area0.y) {
	area0.x = x;
	area0.y = y;
	area0.w = x + copydst.w;
	area0.h = y + copydst.h;
	copy_area_expose();
      }
      break;
    }
  }
}

#ifndef abs
#define abs(x) ((x)<0?-(x):(x))
#endif

plots(p, n)
     int *p;
     int n;
{
  int x, y, x0, y0, x1, y1;
  
  x0 = imgmaxw;
  x1 = -1;
  y0 = imgmaxh;
  y1 = -1;
  if (current_col >= 0) {
    while (n--) {
      x = *p++;
      y = *p++;
      if (x >= 0 && x < imgmaxw && y >= 0 && y < imgmaxh) {
	if (x < x0)
	  x0 = x;
	if (x > x1)
	  x1 = x;
	if (y < y0)
	  y0 = y;
	if (y > y1)
	  y1 = y;
	setpixelcolor(x, y, current_col);
      }
    }
    if (vimg != NULL)
      XClearArea(dsp, viewwin, x0, y0, x1-x0+1, y1-y0+1, True);
    img_expose(x0*zoomfactor-imgofsx, y0*zoomfactor-imgofsy,
	       (x1-x0+1)*zoomfactor, (y1-y0+1)*zoomfactor);
  }
}

edit_line(x, y, type)
{
  int i;
  int *ptrbuf;
  static int x0, y0;
  
  switch(type) {
  case ButtonPress:
    x0 = x;
    y0 = y;
    line_mode = 1;
    break;
  case ButtonRelease:
    if (line_mode == 1) {
      ptrbuf = (int*)malloc(sizeof(int)*2*((abs(x-x0)+abs(y-y0)+1)));
      i = line(ptrbuf, x0, y0, x, y);
      plots(ptrbuf, i);
      free(ptrbuf);
      line_mode = 0;
    }
    break;
  }
}

edit_circle_and_ellipse(x, y, type, em)
{
  int i, rx, ry;
  int *ptrbuf;
  static int x0, y0;
  
  switch(type) {
  case ButtonPress:
    x0 = x;
    y0 = y;
    circle_mode = 1;
    break;
  case ButtonRelease:
    if (circle_mode == 1) {
      rx = abs(x-x0);
      ry = abs(y-y0);
      ptrbuf = (int*)malloc(sizeof(int)*2*(rx+ry)*4);
      if (em == EDIT_CIRCLE)
	i = circle(ptrbuf, x0, y0, ry>rx?ry:rx);
      else
	i = ellipse(ptrbuf, x0, y0, rx, ry);
      plots(ptrbuf, i);
      free(ptrbuf);
      area_flag = False;
      copy_area_expose();
      circle_mode = 0;
    }
    break;
  case MotionNotify:
    if (circle_mode == 1) {
      rx = abs(x-x0);
      ry = abs(y-y0);
      if (em == EDIT_CIRCLE)
	ry = rx = ry>rx?ry:rx;
      area0.x = x0 - rx;
      area0.y = y0 - ry;
      area0.w = x0 + rx + 1;
      area0.h = y0 + ry + 1;
      area_flag = True;
      copy_area_expose();
    }
    break;
  }
}

img_button_sub(x, y, type, em, ox, oy)
{
  switch (em) {
  case EDIT_GETCOLOR:
    set_current_color(*(imgdata+y*imgmaxw+x));
    break;
  case EDIT_PLOT:
    edit_plot(x, y);
    break;
  case EDIT_COPY:
  case EDIT_FILL:
    edit_copy_and_fill(x, y, type, em);
    break;
  case EDIT_LINE:
    edit_line(x, y, type);
    break;
  case EDIT_CIRCLE:
  case EDIT_ELLIPSE:
    edit_circle_and_ellipse(x, y, type, em);
    break;
  case EDIT_SCROLL:
    switch(type) {
    case ButtonPress:
      /* set background scroll */
      if (ox < imgwinwidth/3)
	scroll_dx = -scroll_speed;
      if (ox >= imgwinwidth*2/3)
	scroll_dx = scroll_speed;
      if (oy < imgwinheight/3)
	scroll_dy = -scroll_speed;
      if (oy >= imgwinheight*2/3)
	scroll_dy = scroll_speed;
      break;
    case ButtonRelease:
      /* reset background scroll */
      scroll_dx = scroll_dy = 0;
      break;
    }
    break;
  case EDIT_CANCEL:
  default:
    if (type == ButtonPress) {
      area_flag = False;
      area_mode = line_mode = circle_mode = 0;
      copy_area_expose();
    }
    break;
  }
}

img_button(type, ox, oy, button, st)
     unsigned int st;
{
  int x, y, dx, dy, w, h, em;
  unsigned long pix;
  
  if (ox < 0 || ox >= imgwinwidth ||
      oy < 0 || oy >= imgwinheight)
    return;
  x = (ox + imgofsx) / zoomfactor;
  y = (oy + imgofsy) / zoomfactor;
  if (x != curx) {
    curx = x;
    redraw_window(cursmenu[CURS_CURX].win);
  }
  if (y != cury) {
    cury = y;
    redraw_window(cursmenu[CURS_CURY].win);
  }
  if (x < 0)
    x = 0;
  if (x >= imgfilew)
    x = imgfilew;
  if (y < 0)
    y = 0;
  if (y >= imgfileh)
    y = imgfileh;
  switch(type) {
  case ButtonPress:
  case ButtonRelease:
    switch(button) {
    case Button1:
      em =  0;
      break;
    case Button2:
      em = 1;
      break;
    case Button3:
      em = 2;
      break;
    }
    img_button_sub(x, y, type, edit_mode[em], ox, oy);
    break;
  case MotionNotify:
    if (st & Button1Mask)
      em = 0;
    if (st & Button2Mask)
      em = 1;
    if (st & Button3Mask)
      em = 2;
    img_button_sub(x, y, type, edit_mode[em], ox, oy);
    break;
  }
}

edit_event(ev)
     XEvent *ev;
{
  int x, y, button;
  unsigned int state;
  Window win;
  extern Drawable get_event_window();
  
  win = get_event_window(ev);
  if (win != imgwin)
    return;
  switch (ev->type) {
  case MotionNotify:
    x = ev->xmotion.x;
    y = ev->xmotion.y;
    state= ev->xmotion.state;
    button = 0;
    break;
  case ButtonPress:
  case ButtonRelease:
    x = ev->xbutton.x;
    y = ev->xbutton.y;
    state = ev->xbutton.state;
    button = ev->xbutton.button;
    break;
  default:
    return;
  }
  img_button(ev->type, x, y, button, state);
}

/* End of file */
