/* $Header: /ext/yav/catty/xpx/RCS/grid.c,v 1.8 1994/03/17 17:39:45 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"
#include "griddef.h"

#define GRIDN	3
#define GRIDW	24
#define GRIDH	16
#define MAXGRID	32

char *grid_strfunc(p)
     MENU *p;
{
  static char buf[8];

  sprintf(buf, "%d", grid_size);
  return buf;
}

int gridev();

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask)
static MENU gridmenu[] = {
  {
    GRID_OUT,	MenuModeMaskBorder,
    0, 0, GRIDW, GRIDH,
    0, IMASK, 0,
    gridev, NULL, 0, 0, "<"},
  {
    GRID_NUM,	MenuModeMaskBorder,
    GRIDW+BDW, 0, GRIDW, GRIDH,
    0, IMASK, 0,
    gridev, grid_strfunc, 0, 0, NULL},
  {
    GRID_IN,	MenuModeMaskBorder,
    (GRIDW+BDW)*2, 0, GRIDW, GRIDH,
    0, IMASK, 0,
    gridev, NULL, 0, 0, ">"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

create_grid_window(x, y)
{
  menuwin_create(gridmenu, win, x, y);
}

grid_in()
{
  gridmenu[GRID_IN].mode |= MenuModeMaskOn;
  menuwin_expose_default(&gridmenu[GRID_IN]);
  if (grid_size < MAXGRID) {
    ++grid_size;
    redraw_window(gridmenu[GRID_NUM].win);
    if (grid_mode)
      img_expose(0, 0, imgwinwidth, imgwinheight);
  }
  gridmenu[GRID_IN].mode &= ~MenuModeMaskOn;
  menuwin_expose_default(&gridmenu[GRID_IN]);
}

grid_out()
{
  gridmenu[GRID_OUT].mode |= MenuModeMaskOn;
  menuwin_expose_default(&gridmenu[GRID_OUT]);
  if (grid_size > 1) {
    --grid_size;
    redraw_window(gridmenu[GRID_NUM].win);
    if (grid_mode)
      img_expose(0, 0, imgwinwidth, imgwinheight);
  }
  gridmenu[GRID_OUT].mode &= ~MenuModeMaskOn;
  menuwin_expose_default(&gridmenu[GRID_OUT]);
}

int gridev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    p->mode ^= MenuModeMaskOn;
    switch(p->n) {
    case GRID_OUT:
      grid_out();
      break;
    case GRID_NUM:
      grid_mode = p->mode & MenuModeMaskOn ? True : False;
      img_expose(0, 0, imgwinwidth, imgwinheight);
      break;
    case GRID_IN:
      grid_in();
      break;
    }
    redraw_window(p->win);
    return 1;
  }
  return 0;
}

/* End of file */
