/* $Header: /ext/yav/catty/xpx/RCS/icon.c,v 1.3 1994/03/17 17:39:45 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

#define BITS static char
#include "iconbits"

struct {
  short w;
  short h;
  char *bits;
} icondata[] = {
#include "iconsize"
  {0, 0, NULL}
};

#define IPXMAX	32
static Pixmap ipx[IPXMAX];
static Pixmap ipx2[IPXMAX];
static int ipxn;

Pixmap icon_pixmap(n)
{
  if (n & 0x80)
    return ipx2[(n&0x7f)-1];
  return ipx[n-1];
}

icon_width(n)
{
  return icondata[(n & 0x7f)-1].w;
}

icon_height(n)
{
  return icondata[(n & 0x7f)-1].h;
}

create_icon_pixmap()
{
  for (ipxn = 0; ipxn < IPXMAX; ipxn++) {
    if (icondata[ipxn].bits == NULL)
      break;
    ipx[ipxn] =
      XCreatePixmapFromBitmapData(dsp, DefaultRootWindow(dsp),
				  icondata[ipxn].bits, 
				  icondata[ipxn].w, icondata[ipxn].h, 
				  fg, bg, DefaultDepth(dsp, scr));
    if (ipx[ipxn] == None)
      return error("icon pixmap create error!");
    ipx2[ipxn] =
      XCreatePixmapFromBitmapData(dsp, DefaultRootWindow(dsp),
				  icondata[ipxn].bits, 
				  icondata[ipxn].w, icondata[ipxn].h, 
				  bg, fg, DefaultDepth(dsp, scr));
    if (ipx2[ipxn] == None)
      return error("icon pixmap create error!");
  }
  return 0;
}

free_icon_pixmap()
{
  int i;

  for (i = 0; i < ipxn; i++) {
    XFreePixmap(dsp, ipx[i]);
    XFreePixmap(dsp, ipx2[i]);
  }
}

/* End of file */
