/* $Header: /ext/yav/catty/xpx/RCS/inputstr.c,v 1.2 1994/01/23 17:04:24 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <stdio.h>

extern char *malloc();

/*
 * buf:           str:
 *     abcdef         ghi
 *        ^- pos
 *               |
 *               v
 *     abcghidef
 *           ^- pos
 * return:
 *     insert character count
 */
insert_string(buf, bufsz, pos, str)
     char *buf;
     char *str;
{
  int i;
  int srclen;
  char *p;

  srclen = strlen(str);
  /* move tail */
  i = strlen(buf+pos);
  if (pos + i + srclen >= bufsz)
    return 0;
  if (i == 0) {
    strcpy(buf+pos, str);
  } else {
    p = malloc(i+1);
    if (p == NULL)
      return 0;
    strcpy(p, buf+pos);
    strcpy(buf+pos+srclen, p);
    free(p);
    strncpy(buf+pos, str, srclen);
  }
  return srclen;
}

delete_character(buf, pos)
     char *buf;
{
  int i;
  char *p;
  
  i = strlen(buf) - pos;
  if (i <= 0)
    return 1;
  p = malloc(i+1);
  strcpy(p, buf+pos+1);
  strcpy(buf+pos, p);
  return 0;
}

edit_string(ev, buffer, bufferlen, cursor)
     XKeyEvent *ev;
     char *buffer;
     int *cursor;
{
  int i;
  KeySym key;
  char buf[16];
  
  i = XLookupString(ev, buf, sizeof(buf)-1, &key, NULL);
  buf[i] = '\0';
  switch(buf[0]) {
  case 'F'-0x40:
    key = XK_Right;
    break;
  case 'B'-0x40:
    key = XK_Left;
    break;
  }
  switch(key) {
  case XK_Right:
    if (*cursor < strlen(buffer)) {
      ++*cursor;
      return 1;
    }
    break;
  case XK_Left:
    if (*cursor > 0) {
      --*cursor;
      return 1;
    }
    break;
  case XK_Up:
  case XK_Down:
    break;
  case XK_BackSpace:
    if (*cursor) {
      --*cursor;
      delete_character(buffer, *cursor);
      return 1;
    }
    break;
  case XK_Delete:
    if (*(buffer+*cursor) != '\0') {
      delete_character(buffer, *cursor);
      return 1;
    }
    break;
  case XK_KP_Enter:
  case XK_Return:
    return 2;
  case XK_Escape:
    return 3;
  default:
    i = strlen(buf);
    if (i && buf[0] > ' ') {
      *cursor += insert_string(buffer, bufferlen, *cursor, buf);
      return 1;
    }
  }
  return 0;
}

/* End of file */
