/* $Header: /ext/yav/catty/xpx/RCS/menu.c,v 1.16 1994/03/17 17:39:45 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"
#include "menudef.h"

#define MAXMENU	4
#define MENUW	52
#define MENUH	18

static int menu_sw[MAXMENU];

int mnev();

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask)
static MENU menutbl[] = {
  {
    MENU_QUIT,	MenuModeMaskBorder,
    (MENUW+BDW)*0, 0, MENUW, MENUH,
    0, IMASK, 0,
    mnev, NULL, 0, 0, "Quit"},
  {
    MENU_FILE,	MenuModeMaskBorder,
    (MENUW+BDW)*1, 0, MENUW, MENUH,
    0, IMASK, 0,
    mnev, NULL, 0, 0, "File"},
  {
    MENU_INFO,	MenuModeMaskBorder,
    (MENUW+BDW)*2, 0, MENUW, MENUH,
    0, IMASK, 0,
    mnev, NULL, 0, 0, "Info"},
  {
    MENU_EDIT,	MenuModeMaskBorder,
    (MENUW+BDW)*3, 0, MENUW, MENUH,
    0, IMASK, 0,
    mnev, NULL, 0, 0, "Edit"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

create_menu_window(x, y)
{
  menuwin_create(menutbl, win, x, y);
  return 0;
}

menu_stat_change(i, s)
{
  switch(s) {
  case 0:
    menutbl[i].mode &= ~MenuModeMaskOn;
    break;
  case 1:
    menutbl[i].mode |= MenuModeMaskOn;
    break;
  case 2:
    menutbl[i].mode ^= MenuModeMaskOn;
    break;
  }
  redraw_window(menutbl[i].win);
  switch(i) {
  case MENU_QUIT:
    sw_quit = 1;
    break;
  case MENU_FILE:
    if (menutbl[i].mode & MenuModeMaskOn)
      map_file_window();
    else
      unmap_file_window();
    break;
  case MENU_INFO:
    if (menutbl[i].mode & MenuModeMaskOn)
      map_info_window();
    else
      unmap_info_window();
    break;
  case MENU_EDIT:
    if (menutbl[i].mode & MenuModeMaskOn)
      map_edit_window();
    else
      unmap_edit_window();
    break;
  }
}

int mnev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    menu_stat_change(p->n, 2);
    return 1;
  }
  return 0;
}

/* End of file */
