/* $Header: /ext/yav/catty/xpx/RCS/palset.c,v 1.13 1994/03/17 17:39:45 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

#define PALSETW 24
#define PALSETH 18

MENU palmenu[MAXPALSET+1];

char *palset_strfunc(p)
     MENU *p;
{
  static char buf[8];
  
  sprintf(buf, "%d", p->n);
  return buf;
}

int palset_event(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    if (p->n != current_pal) {
      int oldpal;
      
      oldpal = current_pal;
      current_pal = p->n;
      palmenu[oldpal].mode &= ~MenuModeMaskOn;
      redraw_window(palmenu[oldpal].win);
      p->mode |= MenuModeMaskOn;
      redraw_window(p->win);
      color_update_all();
      update_coled_window();
    }
    return 1;
  }
  return 0;
}

create_palset_window(x, y)
{
  int i;
  MENU *p;

  p = palmenu;
  for (i = 0; i < MAXPALSET; i++) {
    memset(p, 0, sizeof(*p));
    p->n = i;
    p->y = (PALSETH+BDW)*i;
    p->w = PALSETW;
    p->h = PALSETH;
    p->im = ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask;
    p->mode = MenuModeMaskBorder;
    p->event = palset_event;
    p->strfunc = palset_strfunc;
    p++;
  }
  p->n = -1;
  palmenu[current_pal].mode |= MenuModeMaskOn;
  menuwin_create(palmenu, win, x, y);
  return 0;
}

/* End of file */
