/* $Header: /ext/yav/catty/xpx/RCS/scrl.c,v 1.5 1994/03/17 17:49:00 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"
#include "scrldef.h"
#include "icondef.h"

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|\
	       ButtonPressMask|ButtonReleaseMask)

int scrlev();

MENU scrlbar[] = {
  {
    SCRLBAR_TOP,	MenuModeMaskBorder,
    0, 0, 0, 0,
    0, IMASK, 0,
    scrlev, NULL, 0, 0, NULL},
  {
    SCRLBAR_BOTTOM,	MenuModeMaskBorder,
    0, 0, 0, 0,
    0, IMASK, 0,
    scrlev, NULL, 0, 0, NULL},
  {
    SCRLBAR_LEFT,	MenuModeMaskBorder,
    0, 0, 0, 0,
    0, IMASK, 0,
    scrlev, NULL, 0, 0, NULL},
  {
    SCRLBAR_RIGHT,	MenuModeMaskBorder,
    0, 0, 0, 0,
    0, IMASK, 0,
    scrlev, NULL, 0, 0, NULL},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

calc_resize_scrl(x0, y0, w0, h0)
{
  scrlbar[SCRLBAR_TOP].y = y0-IMGSCRLW-1;
  scrlbar[SCRLBAR_BOTTOM].y = y0+h0+1;
  scrlbar[SCRLBAR_TOP].x = scrlbar[SCRLBAR_BOTTOM].x = x0;
  scrlbar[SCRLBAR_TOP].w = scrlbar[SCRLBAR_BOTTOM].w = w0;
  scrlbar[SCRLBAR_TOP].h = scrlbar[SCRLBAR_BOTTOM].h = IMGSCRLW;
  scrlbar[SCRLBAR_LEFT].x = x0-IMGSCRLW-1;
  scrlbar[SCRLBAR_RIGHT].x = x0+w0+1;
  scrlbar[SCRLBAR_LEFT].y = scrlbar[SCRLBAR_RIGHT].y = y0;
  scrlbar[SCRLBAR_LEFT].w = scrlbar[SCRLBAR_RIGHT].w = IMGSCRLW;
  scrlbar[SCRLBAR_LEFT].h = scrlbar[SCRLBAR_RIGHT].h = h0;
}

resize_scrl_sub(n)
{
  MENU *p;
  
  p = scrlbar+n;
  XMoveResizeWindow(dsp, p->win, p->x, p->y, p->w, p->h);
  XMapWindow(dsp, p->win);
}

resize_scrl()
{
  calc_resize_scrl(IMGX, IMGY, imgwinwidth, imgwinheight);
  resize_scrl_sub(SCRLBAR_TOP);
  resize_scrl_sub(SCRLBAR_BOTTOM);
  resize_scrl_sub(SCRLBAR_LEFT);
  resize_scrl_sub(SCRLBAR_RIGHT);
}


create_scrlbar_window()
{
  MENU *p;
  XSetWindowAttributes attr;

  calc_resize_scrl(IMGX, IMGY, imgwinwidth, imgwinheight);
  menuwin_create(scrlbar, win, 0, 0);
  for (p = scrlbar; p->n >= 0; p++) {
    attr.win_gravity = UnmapGravity;
    XChangeWindowAttributes(dsp, p->win, CWWinGravity, &attr);
  }
}

map_scrlbar_window()
{
  MENU *p;
  
  for (p = scrlbar; p->n >= 0; p++)
    XMapWindow(dsp, p->win);
}

unmap_scrlbar_window()
{
  MENU *p;
  
  for (p = scrlbar; p->n >= 0; p++)
    XUnmapWindow(dsp, p->win);
}

int scrlev(p, ev)
     MENU *p;
     XEvent *ev;
{
  int r, w, h;
  
  switch(ev->type) {
  case Expose:
    if (ev->xexpose.count)
      break;
    switch(p->n) {
    case SCRLBAR_TOP:
      r = ICON_up;
      break;
    case SCRLBAR_BOTTOM:
      r = ICON_down;
      break;
    case SCRLBAR_LEFT:
      r = ICON_left;
      break;
    case SCRLBAR_RIGHT:
      r = ICON_right;
      break;
    }
    menu_icon_center(p, r);
    return 1;
  }
  return 0;
}

/* End of file */
