/* $Header: /ext/yav/catty/xpx/RCS/xpx.h,v 1.11 1994/03/17 17:49:25 yav Exp $
 */

#ifndef XPX_CONFIG_H
#include "config.h"
#endif

#ifndef Bool
#define Bool int
#endif
#ifndef True
#define True 1
#endif
#ifndef False
#define False 0
#endif

#define BDW	1		/* Menu window boarder width */

#define MAXPALSET 16
#define MAXCOLSET 16

#define MENUX		8	/* menu x position */
#define MENUY		4	/* menu y position */
#define PALSETX		8	/* color windows x position */
#define PALSETY		54	/* color windows y position */
#define IMGX		140	/* image window x position */
#define IMGY		80	/* image window y position */
#define IMGSCRLW	16	/* image window scroll bar width */

#ifndef MAXPATHLEN
#define MAXPATHLEN 1024
#endif

/* coltbl bitmask */
#define CM_ALLOCED	(1<<0)
#define CM_PRIVATE	(1<<1)
#define CM_UPDATING	(1<<2)
#define CM_UPDATED	(1<<3)
#define CM_REQUEST	(1<<4)

typedef union {
  struct {
    unsigned char padding;
    unsigned char red;
    unsigned char green;
    unsigned char blue;
  } rgb;
  unsigned long all;
} COL;  

typedef struct {
  short n;			/* menu number (-1:end mark) */
  short mode;			/* c.f. MenuModeMask??? */
  short x, y;			/* Position */
  unsigned short w, h;		/* Size */
  Window win;			/* Window id */
  unsigned long im;		/* Inputmask */
  int gr;			/* Gravity */
  int (*event)();		/* Event function */
  char *(*strfunc)();		/* menu str gen func */
  int cursor;		/* cursor position in str */
  int strlen;			/* string length max */
  char *str;			/* display string (input buffer) */
} MENU;

#define MenuModeMaskOn		(1<<0)
#define MenuModeMaskEnter	(1<<1)
#define MenuModeMaskLeft	(1<<2)
#define MenuModeMaskRight	(1<<3)
#define MenuModeMaskBorder	(1<<4)

typedef struct {int x; int y;} POS;
typedef struct {int x; int y; int w; int h;} AREA;

/* End of file */
