/* $Header: /ext/yav/catty/xpx/RCS/zoom.c,v 1.8 1994/03/17 17:39:45 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"
#include "zoomdef.h"

#define ZOOMW	24
#define ZOOMH	16

char *zoom_strfunc(p)
     MENU *p;
{
  static char buf[8];

  sprintf(buf, "%d", zoomfactor);
  return buf;
}

int zmev();

static MENU zoommenu[] = {
  {
    ZOOM_OUT,	MenuModeMaskBorder,
    0, 0, ZOOMW, ZOOMH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    zmev, NULL, 0, 0, "<"},
  {
    ZOOM_NUM,	MenuModeMaskBorder,
    ZOOMW+BDW, 0, ZOOMW, ZOOMH,
    0, ExposureMask, 0,
    NULL, zoom_strfunc, 0, 0, NULL},
  {
    ZOOM_IN,	MenuModeMaskBorder,
    (ZOOMW+BDW)*2, 0, ZOOMW, ZOOMH,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    zmev, NULL, 0, 0, ">"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

create_zoom_window(x, y)
{
  menuwin_create(zoommenu, win, x, y);
}

zoom_change(n)
{
  zoomfactor = n;
  redraw_window(zoommenu[ZOOM_NUM].win);
  image_update_all();
}

zoom_in()
{
  zoommenu[ZOOM_IN].mode |= MenuModeMaskOn;
  menuwin_expose_default(&zoommenu[ZOOM_IN]);
  if (zoomfactor < maxzoom)
    zoom_change(zoomfactor+1);
  zoommenu[ZOOM_IN].mode &= ~MenuModeMaskOn;
  redraw_window(zoommenu[ZOOM_IN].win);
}

zoom_out()
{
  zoommenu[ZOOM_OUT].mode |= MenuModeMaskOn;
  menuwin_expose_default(&zoommenu[ZOOM_OUT]);
  if (zoomfactor > 1)
    zoom_change(zoomfactor-1);
  zoommenu[ZOOM_OUT].mode &= ~MenuModeMaskOn;
  redraw_window(zoommenu[ZOOM_OUT].win);
}

int zmev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    switch(p->n) {
    case ZOOM_OUT:
      if (ev->xbutton.button == 1)
	zoom_out();
      else
	zoom_change(1);
      break;
    case ZOOM_IN:
      if (ev->xbutton.button == 1)
	zoom_in();
      else
	zoom_change(maxzoom);
      break;
    }
    return 1;
  }
  return 0;
}

/* End of file */
